''
'' mydll -- simple dll test
''
'' compile as: fbc -dll mydll.bas (will create mydll.dll and libmydll.dll.a under Win32,
''                                 or libmydll.so under Linux)
''
'' note: libmydll.dll.a is an import library, it's only needed when creating 
''       an executable that calls any of mydll's functions, only distribute 
''       the DLL files with your apps, do not include the import libraries, 
''       they are useless to end-users
''

#Include Once "Blitz3d+.bi"

	''
	'' note: do not add any executable code to the main module (ie: outside 
	'' any function), because that code will never be executed as only DllMain 
	'' is invoked by Windows at the initialization
	''
	

''::::::
''
'' simple exported function, the full prototype is at mydll.bi (the EXPORT clause must be used here)
''
Function Distance2D ( ByVal x1 As Single, ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single ) As Single Export
	Dim x As Single
	Dim y As Single

	x=x1-x2
	y=y1-y2
	Function = Sqr((x*x)+(y*y))
	
End Function

Function Distance3D ( ByVal x1 As Single, ByVal y1 As Single, ByVal z1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByVal z2 As Single ) As Single Export
	Dim x As Single
	Dim y As Single
	Dim z As Single

	x=x1-x2
	y=y1-y2
	z=z1-z2
	Function = Sqr((x*x)+(y*y)+(z*z))
	
End Function

Function PointInRect( ByVal x As Single, ByVal y As Single, ByVal rx As Single, ByVal ry As Single, ByVal rw As Single, ByVal rh As Single ) As Single Export
    Function = (x >= rx) And (x <= rx+rw) And (y >= ry) And (y <= ry+rh)
End Function

' Camera 

Function GetCamClsMode ( ByVal camera As Any Ptr, ByVal index As String ) As Integer Export
    If LCase(index) = "color" Then Function = Bit(Peek(Integer, camera + 608),0)
    If LCase(index) = "zbuffer" Then Function = Bit(Peek(Integer, camera + 608),256)
End Function

Function GetCamClsColorR ( ByVal camera As Any Ptr ) As Integer Export
    Function = 255 * Peek(Single, camera + 596)
End Function

Function GetCamClsColorG ( ByVal camera As Any Ptr ) As Integer Export
    Function = 255 * Peek(Single, camera + 600)
End Function

Function GetCamClsColorB ( ByVal camera As Any Ptr ) As Integer Export
    Function = 255 * Peek(Single, camera + 604)
End Function

Function GetCamProjMode ( ByVal camera As Any Ptr ) As Integer Export
    Function = Peek(Integer, camera + 612)
End Function

Function GetCamRangeNear ( ByVal camera As Any Ptr ) As Single Export
    Function = Peek(Single, camera + 640)
End Function

Function GetCamRangeFar ( ByVal camera As Any Ptr ) As Single Export
    Function = Peek(Single, camera + 644)
End Function

Function GetCamZoom ( ByVal camera As Any Ptr ) As Single Export
    Function = Peek(Single, camera + 576)
End Function

Function GetCamViewPortX ( ByVal camera As Any Ptr ) As Integer Export
    Function = Peek(Integer, camera + 580)
End Function

Function GetCamViewPortY ( ByVal camera As Any Ptr ) As Integer Export
    Function = Peek(Integer, camera + 584)
End Function

Function GetCamViewPortW ( ByVal camera As Any Ptr ) As Integer Export
    Function = Peek(Integer, camera + 588)
End Function

Function GetCamViewPortH ( ByVal camera As Any Ptr ) As Integer Export
    Function = Peek(Integer, camera + 592)
End Function

Function GetCamFogMode ( ByVal camera As Any Ptr ) As Integer Export
    Function = Peek(Integer, camera + 636)
End Function

Function GetCamFogNear ( ByVal camera As Any Ptr ) As Single Export
    Function = Peek(Single, camera + 628)
End Function

Function GetCamFogFar ( ByVal camera As Any Ptr ) As Single Export
    Function = Peek(Single, camera + 632)
End Function

Function GetCamFogColorR ( ByVal camera As Any Ptr ) As Integer Export
    Function = 255 * Peek(Single, camera + 616)
End Function

Function GetCamFogColorG ( ByVal camera As Any Ptr ) As Integer Export
    Function = 255 * Peek(Single, camera + 620)
End Function

Function GetCamFogColorB ( ByVal camera As Any Ptr ) As Integer Export
    Function = 255 * Peek(Single, camera + 624)
End Function

Function GetCamFOV ( ByVal camera As Any Ptr ) As Single Export 
    Const ToDeg As Single = 57.2957795
    Function = 2 * Atn (1.0 / Peek(Single, camera + 576) ) * ToDeg
End Function

Sub SetCamFOV ( ByVal camera As Any Ptr, ByVal FOV As Single ) Export
    Const ToRad As Single = 0.01745329
    Poke Single, camera + 576, 1.0 / Tan((FOV* ToRad)/2.0)
    Poke Integer, camera + 860,0
End Sub


' Light

Sub SetLightType ( ByVal light As Any Ptr, ByVal lighttype As Integer ) Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Poke Integer, address, lighttype
End Sub

Sub SetLightDiffuse ( ByVal light As Any Ptr, ByVal dred As Integer, ByVal dgreen As Integer, ByVal dblue As Integer, ByVal dalpha As Single ) Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Poke Single, address+4, dred / 255
    Poke Single, address+8, dgreen / 255
    Poke Single, address+12, dblue / 255
    Poke Single, address+16, dalpha
End Sub

Sub SetLightSpecular ( ByVal light As Any Ptr, ByVal dred As Integer, ByVal dgreen As Integer, ByVal dblue As Integer, ByVal dalpha As Single ) Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Poke Single, address+20, dred / 255
    Poke Single, address+24, dgreen / 255
    Poke Single, address+28, dblue / 255
    Poke Single, address+32, dalpha
End Sub

Sub SetLightAmbient ( ByVal light As Any Ptr, ByVal dred As Integer, ByVal dgreen As Integer, ByVal dblue As Integer, ByVal dalpha As Single ) Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Poke Single, address+36, dred / 255
    Poke Single, address+40, dgreen / 255
    Poke Single, address+44, dblue / 255
    Poke Single, address+48, dalpha
End Sub

Sub SetLightMaxRange ( ByVal light As Any Ptr, ByVal range As Single ) Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Poke Single, address+76, range
End Sub

Sub SetLightAtten0 ( ByVal light As Any Ptr, ByVal value As Single ) Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Poke Single, address+84, value
End Sub

Function GetLightAtten0 ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+84)
End Function

Sub SetLightAtten1 ( ByVal light As Any Ptr, ByVal value As Single ) Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Poke Single, address+92, value
End Sub

Function GetLightAtten1 ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+92)
End Function

Sub SetLightFallOff ( ByVal light As Any Ptr, ByVal value As Single ) Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Poke Single, address+80, value
End Sub

Function GetLightFallOff ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+80)
End Function

Function GetLightType ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Integer, address)
End Function

Function GetLightMaxRange ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+76)
End Function

Function GetLightRange ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 1.0/Peek(Single, address+88)
End Function

Function GetLightInner ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+96) * 57.2957795
End Function

Function GetLightOuter ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+100) * 57.2957795
End Function

Function GetLightDiffuseR ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+4)
End Function

Function GetLightDiffuseG ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+8)
End Function

Function GetLightDiffuseB ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+12)
End Function

Function GetLightDiffuseA ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+16)
End Function

Function GetLightSpecularR ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+20)
End Function

Function GetLightSpecularG ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+24)
End Function

Function GetLightSpecularB ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+28)
End Function

Function GetLightSpecularA ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+32)
End Function

Function GetLightAmbientR ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+36)
End Function

Function GetLightAmbientG ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+40)
End Function

Function GetLightAmbientB ( ByVal light As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = 255 * Peek(Single, address+44)
End Function

Function GetLightAmbientA ( ByVal light As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, light+576)
    Function = Peek(Single, address+48)
End Function

' Entity

Function GetEntityAlpha ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 596)
End Function

Function GetEntityScaleX ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 76)
End Function

Function GetEntityScaleY ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 80)
End Function 

Function GetEntityScaleZ ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 84)
End Function

Function GetEntityAutoFade ( ByVal entity As Any Ptr ) As Integer Export
   Function = Peek(Integer, entity + 600)
End Function

Sub ClrEntityAutoFade ( ByVal entity As Any Ptr ) Export
   Poke Integer, entity + 600, 0
End Sub

Function GetEntityAutoNear ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 604)
End Function

Function GetEntityAutoFar ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 608) 
End Function

Function GetEntityOrder ( ByVal entity As Any Ptr ) As Integer Export
   Function = Peek(Integer, entity + 228)
End Function

Function GetNextEntity ( ByVal entity As Any Ptr ) As Integer Export
   Function = Peek(Integer, entity + 16)
End Function

Function GetLastEntity ( ByVal entity As Any Ptr ) As Integer Export
   Function = Peek(Integer, entity + 20)
End Function

Function GetEntityHidden ( ByVal entity As Any Ptr ) As Integer Export
   Function = Bit(Peek(Integer, entity + 24),0)
End Function

Function GetEntityRadiusX ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 232)
End Function

Function GetEntityRadiusY ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 236)
End Function 

Function GetEntityBoxX ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 264)
End Function

Function GetEntityBoxY ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 268)
End Function 

Function GetEntityBoxZ ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 272)
End Function

Function GetEntityBoxW ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 276)- Peek(Single, entity + 264)
End Function

Function GetEntityBoxH ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 280)- Peek(Single, entity + 268)
End Function

Function GetEntityBoxD ( ByVal entity As Any Ptr ) As Single Export
   Function = Peek(Single, entity + 284)- Peek(Single, entity + 272)
End Function

Function GetEntityPickmode ( ByVal entity As Any Ptr ) As Integer Export
   Function = Peek(Integer, entity + 288)
End Function

Function GetEntityObscurer ( ByVal entity As Any Ptr ) As Integer Export
   Function = Bit(Peek(Integer, entity + 292),0)
End Function

Function GetEntityColorR ( ByVal entity As Any Ptr ) As Integer Export
   Dim address As Integer
   address = Peek(Integer, entity + 580) ' entity brush structure   
   Function = 255 * Peek(Single, address+16)
End Function

Function GetEntityColorG ( ByVal entity As Any Ptr ) As Integer Export
   Dim address As Integer
   address = Peek(Integer, entity + 580) ' entity brush structure   
   Function = 255 * Peek(Single, address+20)
End Function

Function GetEntityColorB ( ByVal entity As Any Ptr ) As Integer Export
   Dim address As Integer
   address = Peek(Integer, entity + 580) ' entity brush structure   
   Function = 255 * Peek(Single, address+24)
End Function

Function GetEntityShine ( ByVal entity As Any Ptr ) As Single Export
   Dim address As Integer
   address = Peek(Integer, entity + 580) ' entity brush structure   
   Function = Peek(Single, address+28)
End Function

Function GetEntityBlend ( ByVal entity As Any Ptr ) As uInteger Export
   Dim address As Integer
   address = Peek(Integer, entity + 584) ' entity brush structure   
   Function = Peek(uInteger, address+412)
End Function

Function GetEntityFX ( ByVal entity As Any Ptr ) As uInteger Export
   Dim address As Integer
   address = Peek(Integer, entity + 584) ' entity brush structure   
   Function = Peek(uInteger, address+448)
End Function 

Sub RefreshEntityBrush ( ByVal entity As Any Ptr ) Export
   Poke Integer, entity+588, 1
End Sub


' Texture

Function GetTextureBlend ( ByVal texture As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, texture) ' texture structure     
    Function = Peek(Integer, address + 24)
End Function 

Function GetTextureCoords ( ByVal texture As Any Ptr ) As Integer Export
    Dim address As Integer
    address = Peek(Integer, texture) ' texture structure     
    Function = Peek(Integer, address + 28)
End Function 

Function GetTextureScaleU ( ByVal texture As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, texture) ' texture structure     
    Function = 1.0 / Peek(Single, address + 36)
End Function 

Function GetTextureScaleV ( ByVal texture As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, texture) ' texture structure     
    Function = 1.0 / Peek(Single, address + 40)
End Function 

Function GetTexturePositionU ( ByVal texture As Any Ptr ) As Single Export 
    Dim address As Integer
    address = Peek(Integer, texture) ' texture structure
    Function = -Peek(Single, address + 44)
End Function 

Function GetTexturePositionV ( ByVal texture As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, texture) ' texture structure
    Function = -Peek(Single, address + 48)
End Function

Sub ScrollTexture ( ByVal texture As Any Ptr, UIncrement As Single, VIncrement As Single ) Export
    Dim address As Integer
    address = Peek(Integer, texture) ' texture structure
    Poke Single, address + 84, Peek(Single, address + 84)- UIncrement
    Poke Single, address + 88, Peek(Single, address + 88)- VIncrement
    Poke uByte, address + 56,1
End Sub

Function GetTextureRotation ( ByVal texture As Any Ptr ) As Single Export
    Dim address As Integer
    address = Peek(Integer, texture) ' texture structure
    Function = -(Peek(Single, address + 52) * 57.2957795)
End Function

Function GetTextureFlags ( ByVal texbuffer As Any Ptr ) As Integer Export
  Function = Peek(Short, texbuffer)
End Function


'Brush

Function GetBrushBlend ( ByVal brush As Any Ptr ) As Integer Export
  Dim address As Integer
  address = Peek(Integer, brush)
  Function = Peek(Integer, address + 4)
End Function 

Function GetBrushColorRGB ( ByVal brush As Any Ptr ) As Integer Export
  Function = (GetBrushColorR(brush) Shl 16) Or (GetBrushColorG(brush) Shl 8) Or GetBrushColorB(brush)
End Function 

Function GetBrushColorR ( ByVal brush As Any Ptr ) As Integer Export
  Dim address As Integer
  address = Peek(Integer, brush)  
  Function = Peek(Single, address + 16)*255  
End Function 

Function GetBrushColorG ( ByVal brush As Any Ptr ) As Integer Export
  Dim address As Integer
  address = Peek(Integer, brush)
  Function = Peek(Single, address + 20)*255  
End Function 

Function GetBrushColorB ( ByVal brush As Any Ptr ) As Integer Export
  Dim address As Integer
  address = Peek(Integer, brush)
  Function = Peek(Single, address + 24)*255  
End Function 

Function GetBrushFX ( ByVal brush As Any Ptr ) As Integer Export
  Dim address As Integer
  address = Peek(Integer, brush)
  Function = Peek(Integer, address + 40)
End Function 

Function GetBrushShininess ( ByVal brush As Any Ptr ) As Single Export
  Dim address As Integer
  address = Peek(Integer, brush)
  Function = Peek(Single, address + 28)
End Function 

Function GetBrushAlpha ( ByVal brush As Any Ptr ) As Single Export
  Dim address As Integer
  address = Peek(Integer, brush)
  Function = Peek(Single, address + 32)
End Function

Function GetBrushNumTextures ( ByVal brush As Any Ptr ) As Integer Export
  Dim address As Integer
  address = Peek(Integer, brush)
  Function = Peek(Integer, address + 8)
End Function

Sub SetBrushTexture ( ByVal brush As Any Ptr, ByVal index As Integer, ByVal texture As Any Ptr ) Export
  Dim brushstruc As Integer
  Dim texbuffer As Integer
  brushstruc = Peek(Integer, brush)
  If index >-1 And index < Peek(Integer, brushstruc + 8) Then
    texbuffer = 0
    If texture <> 0 Then texbuffer = GetTextureBuffer(texture)
    Poke Integer, brushstruc + 44 + index*16, texbuffer
  End If
End Sub

Function GetTextureBuffer( ByVal texture As Any Ptr ) As Integer
    Dim address As Integer
    address =  Peek(Integer,texture)
    address =  Peek(Integer,address+4)
    address =  Peek(Integer,address+40)
    Function = Peek(Integer,address)
End Function


'Sprites

Function GetSpriteHandleX ( ByVal sprite As Any Ptr ) As Single Export
   Function = Peek(Single, sprite + 644)
End Function

Function GetSpriteHandleY ( ByVal sprite As Any Ptr ) As Single Export
   Function = Peek(Single, sprite + 648)
End Function

Function GetSpriteAngle ( ByVal sprite As Any Ptr ) As Single Export
   Function = Peek(Single, sprite + 652) * 57.2957795
End Function

Function GetSpriteScaleX ( ByVal sprite As Any Ptr ) As Single Export
   Function = Peek(Single, sprite + 656)
End Function

Function GetSpriteScaleY ( ByVal sprite As Any Ptr ) As Single Export
   Function = Peek(Single, sprite + 660)
End Function

Function GetSpriteViewMode ( ByVal sprite As Any Ptr ) As Integer Export
   Function = Peek(Integer, sprite + 676)
End Function

'Color Functions

Function GetIntRed( ByVal hue As Integer ) As Integer Export
	Function = (hue And &h000000FF)
End Function

Function GetIntGreen( ByVal hue As Integer ) As Integer Export
	Function = (hue And &h0000FF00) Shr 8
End Function

Function GetIntBlue( ByVal hue As Integer ) As Integer Export
	Function = (hue And &h00FF0000) Shr 16
End Function

Function GetIntAlpha( ByVal hue As Integer ) As Integer Export
	Function = (hue And &hFF000000) Shr 24
End Function

Function GetRGBInt( ByVal r As uInteger, ByVal g As uInteger, ByVal b As uInteger ) As uInteger Export
	Function = b+(g Shl 8)+(r Shl 16)+(255 Shl 24)
End Function

Function GetRGBAInt( ByVal r As uInteger, ByVal g As uInteger, ByVal b As uInteger, ByVal a As uInteger ) As uInteger Export
	Function = b+(g Shl 8)+(r Shl 16)+(a Shl 24)
End Function

'Memory Functions

Function PeekByte ( ByVal address As Any Ptr ) As Integer Export
  Function = Peek(uByte, address)
End Function

Function PeekShort ( ByVal address As Any Ptr ) As Integer Export
  Function = Peek(Short, address)
End Function

Function PeekInt ( ByVal address As Any Ptr ) As unSigned Integer Export
  Function = Peek(Long, address)
End Function 

Function PeekFloat ( ByVal address As Any Ptr ) As Single Export
  Function = Peek(Single, address)
End Function

Sub PokeByte ( ByVal address As Any Ptr, ByVal value As uByte ) Export
  Poke uByte, address, value
End Sub

Sub PokeShort ( ByVal address As Any Ptr, ByVal value As Short ) Export
  Poke Short, address, value
End Sub

Sub PokeInt ( ByVal address As Any Ptr, ByVal value As Integer ) Export
  Poke Integer, address, value
End Sub

Sub PokeFloat ( ByVal address As Any Ptr, ByVal value As Single ) Export
  Poke Single, address, value
End Sub


'Math Functions

Function CurveValue ( ByVal newvalue As Single, ByVal oldvalue As Single , ByVal increments As Single ) As Single Export
    If increments>1 Then oldvalue=oldvalue-(oldvalue-newvalue)/increments
    If increments<=1 Then oldvalue=newvalue
    Function = oldvalue
End Function

Function WrapValue (ByVal value As Single, ByVal lo As Single, ByVal hi As Single) As Single Export
    Dim i As Single
    Dim r As Single
    i=Fix(value/(hi-lo))
    r=i*(hi-lo)
    Function = (value-r)+lo
End Function 

Function ClampValue (ByVal value As Single, ByVal lo As Single, ByVal hi As Single) As Single Export
	If value<lo Then value=lo
	If value>hi Then value=hi
	Function = value
End Function

Function Min (ByVal value1 As Single, ByVal value2 As Single) As Single Export
	If value1 < value2 Then value2 = value1
	Function = value2
End Function

Function Max (ByVal value1 As Single, ByVal value2 As Single) As Single Export
	If value1 > value2 Then value2 = value1
	Function = value2
End Function